/**
 * Dictionary map of the different binaries.
 */
export interface ConfigFile {
    selenium?: string;
    chrome?: string;
    ie?: string;
}
/**
 * The configuration for webdriver-manager.
 */
export declare class Config {
    static configFile: string;
    static packageFile: string;
    static cwd: string;
    static nodeModuleName: string;
    static localInstall: string;
    static parentPath: string;
    static dir: string;
    static folder: string;
    static isProjectVersion: boolean;
    static isLocalVersion: boolean;
    static getFile_(jsonFile: string): string;
    static getConfigFile_(): string;
    static getPackageFile_(): string;
    static getFolder_(folder: string): string;
    static getSeleniumDir(): string;
    static getBaseDir(): string;
    /**
     * Get the binary versions from the configuration file.
     * @returns A map of the versions defined in the configuration file.
     */
    static binaryVersions(): ConfigFile;
    /**
     * Get the CDN urls from the configuration file.
     * @returns A map of the CDN versions defined in the configuration file.
     */
    static cdnUrls(): ConfigFile;
    /**
     * Get the package version.
     */
    static getVersion(): string;
}
